proc start_time {} {return [expr ([eval ns-random] / 2147483647.0) * 0.1]}

proc sim {tcptype queuetype sources cross qlen duration file seed delay rate} {
    ns-random $seed
    set ns [new Simulator]
    global traces;
    set inc 0.01

    # determine the actual queutype and save the one asked for 
    # assign queueing parameters -- simulate random drop with RED

    if { [string match RandomDrop* $queuetype ] } then {
	set queuetype [join \
		[concat "RED" \
		[string range $queuetype [string length "RandomDrop"] end ]]\
		"" ]
	Queue/$queuetype set thresh_ [expr 2* $qlen]
	Queue/$queuetype set maxthresh_ [expr 2* $qlen]
    } elseif { [string match RED* $queuetype ] } then {
	Queue/$queuetype set thresh_ [expr $qlen * 0.5]
	Queue/$queuetype set maxthresh_ [expr $qlen * 0.75]
    }

  
    for { set i 1 } {$i <= [expr (2*$sources)+3 + 2*$cross]} {incr i} {
	set n($i) [$ns node]
    }
    set rtr1 [expr $sources+1]
    set rtr2 [expr $rtr1+1]
    set rtr3 [expr $rtr2+1]
    $ns duplex-link $n($rtr1) $n($rtr2) 10Mb  $delay DropTail
    $ns duplex-link $n($rtr2) $n($rtr3) 1.5Mb 10ms $queuetype
    for {set i 1} {$i<=$sources} {incr i} {
	$ns duplex-link $n($i) $n($rtr1) 1Mb 10ms DropTail
	$ns duplex-link $n($rtr3) $n([expr $i+$rtr3]) 10Mb 10ms DropTail
    }
    for {set i 1} {$i<=$cross} {incr i} {
	set j [expr $i + 2*$sources +3]
	$ns duplex-link $n($j) $n($rtr2) 10Mb 10ms DropTail
	$ns duplex-link $n($rtr3) $n([expr $j+$cross]) 10Mb 10ms DropTail
    }
    for {set i 1} {$i<=$sources} {incr i} {
	set T($i) [new $tcptype]
	set F($i) [$T($i) attach-source FTP]
	set R($i) [new Agent/TCPSink/Active]
	$ns attach-agent  $n($i) $T($i)
	$ns attach-agent $n([expr $i+$rtr3]) $R($i) 
	$ns connect $T($i) $R($i)
	# $ns at [expr $i+[start_time]] "$F($i) start"
	$ns at [start_time] "$F($i) start"
    }
    for {set i 1} {$i<=$cross} {incr i} {
	set j [expr $i+(2*$sources+3)]
	set e($j) [new Application/Traffic/Exponential]
        $e($j) set packet_size_ 1000
        $e($j) set burst_time_ 2500ms
        $e($j) set idle_time_ 2500ms
        $e($j) set rate_ $rate
	set T($j) [new Agent/UDP]

	# order of attach is *important*.  The whole thing fails is these
	# attached are reversed

	$ns attach-agent  $n($j) $T($j)
	$e($j) attach-agent $T($j)
	set R($j) [new Agent/Null]
	$ns attach-agent $n([expr $j+$cross]) $R($j) 
	$ns connect $T($j) $R($j)
	$ns at [start_time] "$e($j) start"
    }
    if { [lsearch $traces "TCP"] != -1 } {
	for {set i 1} {$i<=$sources} {incr i} {
	    $T($i) trace cwnd_
	    $T($i) trace active_closes_
	    $T($i) attach [open "$file.tcp_trace.$i" "w"]
	}
	for {set i 1} {$i<=$cross} {incr i} {
	    set j [expr $i + 2*$sources +3]
	    $T($j) trace cwnd_
	    $T($j) trace active_closes_
	    $T($j) attach [open "$file.tcp_trace.cross$i" "w"]
	}
    }
    if { [lsearch $traces "throughput"] != -1 } {
	set th [open "$file.throughput" "w"]
    	for {set i 1} {$i<=$sources} {incr i} {
	    $ns at $duration [join \
		    [list  "puts $th \"$i \[" $R($i) "throughput\]\"" ]  " "]
	}
#	for {set i 1} {$i<=$cross} {incr i} {
#	    set j [expr $i + 2*$sources +3]
#	    $ns at $duration [join \
#		    [list  "puts $th \"cross$i \[" $R($j) "throughput\]\"" ]  " "]
#	}
	$ns at $duration "close $th"
    }


    $ns queue-limit $n($rtr1) $n($rtr2) [expr $qlen]
    $ns queue-limit $n($rtr2) $n($rtr3) [expr $qlen]
    if { [lsearch $traces "queue"] != -1 } {
	$ns trace-queue $n($rtr1) $n($rtr2) [open "$file.queue1" "w"]
	$ns trace-queue $n($rtr2) $n($rtr3) [open "$file.queue2" "w"]
    }

    if { [lsearch $traces "stats"] != -1 } {
	for {set i 0} { $i < 2 } { incr i} {
	    set stats [open "$file.stats$i" "w"]
	    set monitor [$ns monitor-queue $n([expr $rtr1+$i]) \
		    $n([expr $rtr1+$i+1]) ""]
	    $ns at $duration "puts $stats \"integrator avg: \[ expr (\[[$monitor get-pkts-integrator] set sum_ \])/$duration\]\""
	    set samples [new Samples];
	    for { set j 0 } { $j < $duration } { set j [expr $j + $inc]} {
		$ns at $j "$samples newpoint \[$monitor set pkts_ \]"
	    }
	    $ns at $duration "puts $stats \"avg: \[$samples mean\]\nvar: \[$samples variance \]\nstd. dev: \[expr sqrt(\[$samples variance\])\]\""
	    $ns at $duration "close $stats"
	}
    }
#    if { [lsearch $traces "closes"] != -1 } {
#	if { [string match *Active* $queuetype ] } {
#	    set closes [open "$file.closes" "w" ]
#	    for { set i 1}  { $i <= $sources } { incr i} {
#		if {[string first "Active" $tcptype] != -1 } {
#		    $ns at $duration "puts $closes \"$i \[$T($i) set active_closes_\] \[$T($i) set closes_\] \[$T($i) set nrexmit_\] \[$T($i) set active_packets_\]\""
#		} else {
#		    $ns at $duration "puts $closes \"$i -  \[$T($i) set closes_\] \[$T($i) set nrexmit_\] -\""
#		}
#	    }
#	}
#    }
    $ns at $duration "exit 0"
    $ns run
}

set traces [ list "throughput"]

if { [llength $argv]>0} then { set tcptype [lindex $argv 0]}\
else {set tcptype "Agent/TCP"}
if { [llength $argv]>1} then { set queuetype [lindex $argv 1]}\
else {set queuetype "DropTail"}
if { [llength $argv]>2} then { set sources [lindex $argv 2]}\
else {set sources 5}
if { [llength $argv]>3} then { set cross [lindex $argv 3]}\
else {set cross 5 }
if { [llength $argv]>4} then { set qlen [lindex $argv 4]}\
else {set qlen 50 }
if { [llength $argv]>5} then { set duration [lindex $argv 5]}\
else {set duration 10}
if { [llength $argv]>6} then { set file [lindex $argv 6]}\
else {set file "sim"}
if { [llength $argv]>7} then { set seed [lindex $argv 7]}\
else {set seed 0}
if { [llength $argv]>8} then { set delay [lindex $argv 8]}\
else {set delay "10ms"}
if { [llength $argv]>9} then { set rate [lindex $argv 9]}\
else {set rate "100k"}


sim $tcptype $queuetype $sources $cross $qlen $duration $file $seed $delay $rate
