proc start_time {} {return [expr ([eval ns-random] / 2147483647.0) * 0.1]}

proc sim {tcptype queuetype sources qlen duration file seed delay bw} {
    ns-random $seed
    set ns [new Simulator]
    global traces;

    set start 0.0
    set inc 0.1

    # determine the actual queutype and save the one asked for 
    # assign queueing parameters -- simulate random drop with RED

    if { [string match RandomDrop* $queuetype ] } then {
	set queuetype [join \
		[concat "RED" \
		[string range $queuetype [string length "RandomDrop"] end ]]\
		"" ]
	Queue/$queuetype set thresh_ [expr 2* $qlen]
	Queue/$queuetype set maxthresh_ [expr 2* $qlen]
    } elseif { [string match RED* $queuetype ] } then {
	Queue/$queuetype set thresh_ [expr $qlen * 0.5]
	Queue/$queuetype set maxthresh_ [expr $qlen * 0.75]
    }

  
    for { set i 1 } {$i <= [expr 2*$sources+3]} {incr i} {
	set n($i) [$ns node]
    }
    set rtr1 [expr $sources+1]
    set rtr2 [expr $rtr1+1]
    set rtr3 [expr $rtr2+1]
    $ns duplex-link $n($rtr1) $n($rtr2) $bw $delay $queuetype
    $ns duplex-link $n($rtr2) $n($rtr3) 10Mb 10ms DropTail
    for {set i 1} {$i<=$sources} {incr i} {
	$ns duplex-link $n($i) $n($rtr1) 10Mb 10ms DropTail
	$ns duplex-link $n($rtr3)  $n([expr $i+$rtr3]) 10Mb 10ms DropTail
    }
    for {set i 1} {$i<=$sources} {incr i} {
	set T($i) [new $tcptype]
	set F($i) [$T($i) attach-source FTP]
	set R($i) [new Agent/TCPSink/Active]
	$ns attach-agent  $n($i) $T($i)
	$ns attach-agent $n([expr $i+$rtr3]) $R($i) 
	$ns connect $T($i) $R($i)
#	$ns at [expr $i+[start_time]] "$F($i) start"
	$ns at [start_time] "$F($i) start"
    }
    if { [lsearch $traces "TCP"] != -1 } {
	for {set i 1} {$i<=$sources} {incr i} {
	    $T($i) trace cwnd_
	    $T($i) trace active_closes_
	    $T($i) attach [open "$file.tcp_trace.$i" "w"]
	}
    }

    if { [lsearch $traces "throughput"] != -1 } {
	set th [open "$file.throughput" "w"]
    	for {set i 1} {$i<=$sources} {incr i} {
	    $ns at $duration [join \
		    [list  "puts $th \"$i \[" $R($i) "throughput\]\"" ]  " "]
	}
    	$ns at $duration "close $th"
    }



    $ns queue-limit $n($rtr1) $n($rtr2) [expr $qlen]
    if { [lsearch $traces "queue"] != -1 } {
	$ns trace-queue $n($rtr1) $n($rtr2) [open "$file.queue" "w"]
    }
    if { [lsearch $traces "stats"] != -1 } {
	set stats [open "$file.stats" "w"]
	if { [lsearch $traces "qsamps" ] != -1} { 
	    set qtrace [open "$file.qlen" "w"]
	}
	set monitor [$ns monitor-queue $n($rtr1) $n($rtr2) ""]
#	$ns at $duration "puts $stats \"integrator avg: \[ expr (\[[$monitor get-pkts-integrator] set sum_ \])/$duration\]\""
	set samples [new Samples];
	for { set i $start } { $i < $duration } { set i [expr $i + $inc]} {
	    $ns at $i "$samples newpoint \[$monitor set pkts_ \]"
	    if { [lsearch $traces "qsamps" ] != -1} { 
		$ns at $i "puts $qtrace \"$i \[$monitor set pkts_\]\""
	    }
	}
	$ns at $duration "puts $stats \"\[$samples mean\] \[$samples variance \]  \[expr sqrt(\[$samples variance\])\] \[$samples max\] \[$samples min\]\""
	$ns at $duration "close $stats"
	if { [lsearch $traces "qsamps" ] != -1} { 
	    $ns at $duration "close $qtrace"
	}

    }
    $ns at $duration "exit 0"
    $ns run
}

set traces [ list "qsamps" "samples" "stats" "throughput"]

if { [llength $argv]>0} then { set tcptype [lindex $argv 0]}\
else {set tcptype "Agent/TCP"}
if { [llength $argv]>1} then { set queuetype [lindex $argv 1]}\
else {set queuetype "DropTail"}
if { [llength $argv]>2} then { set sources [lindex $argv 2]}\
else {set sources 5}
if { [llength $argv]>3} then { set qlen [lindex $argv 3]}\
else {set qlen 50 }
if { [llength $argv]>4} then { set duration [lindex $argv 4]}\
else {set duration 10}
if { [llength $argv]>5} then { set file [lindex $argv 5]}\
else {set file "sim"}
if { [llength $argv]>6} then { set seed [lindex $argv 6]}\
else {set seed 0}
if { [llength $argv]>7} then { set delay [lindex $argv 7]}\
else {set delay "10ms"}
if { [llength $argv]>8} then { set bw [lindex $argv 8]}\
else {set bw "1.5Mb"}


sim $tcptype $queuetype $sources $qlen $duration $file $seed $delay $bw
